#!/bin/sh
#
# (c) 2000 Sun Microsystems, Inc.
#

#
# Interface script for the QS qstat command
#
# This script gets started by cod_qstd to check
# whether job 'jobid' still runs
#
#
# $1 = jobid
#

out=/tmp/qstd_debug
date=`date`
touch $out
echo "$date Qstat called" >> $out

jobid=$1 

if [ "x$CODINE_ROOT" = "x" ]; then
   CODINE_ROOT=/usr/CODINE
fi

ARC=`$CODINE_ROOT/util/arch`
QSTAT=$CODINE_ROOT/bin/$ARC/qstat
unset COD_DEBUG_LEVEL

if [ ! -x $QSTAT ]; then
   echo "$0: $QSTAT is not executable" >> $out
   exit 1
fi

# $QSTAT | sed -n -e '3,$p' | awk "{ if (\$1 == $jobid) print \$1 } "|grep $jobid
titleline=`$QSTAT | head -2`
status=`$QSTAT | awk "{ if (\\$1 == $jobid) print \\$0 }"`
echo $status | grep $jobid > /dev/null

if [ $? -ne 0 ]; then
   echo "$0: job $jobid exited" >> $out
   echo "job $jobid exited"
   exit 2
else
   echo "$0: job $jobid still running" >> $out
   echo "$titleline" 
   echo "$status" 
   exit 0
fi
