#!/bin/sh
#
# create-rc-startup.sh
#
# (c) 2001 Sun Microsystems, Inc.
# 
# Create SGE 5.2 startup script
#
# Arguments:
#
# $1 = <path_to_your_$CODINE_ROOT_directory>
# $2 = "0" if you are using the service codine_commd
#         or
#      <portnumber> if you use the variable $COMMD_PROT instead
# $3 = <default> 
#         or
#      the name of your $COD_CELL variable
# $4 = path to the template script $CODINE_ROOT/util/startup_template
#

PATH=/bin:/usr/bin

if [ $# != 4 ]; then
   echo "usage: $0 \$CODINE_ROOT 0|<port> default|\$COD_CELL file_to_read" >&2
   echo >&2
   echo command failed >&2
   exit 1
fi

QSYST_ROOT=CODINE_ROOT
QSYST_CELL=COD_CELL
QSYST_ROOT_VAL=$CODINE_ROOT
QSYST_CELL_VAL=$3
QSYST_NAME="Sun Grid Engine"
QSYST_MASTER_NAME=cod_qmaster
QSYST_SCHEDD_NAME=cod_schedd
QSYST_SHADOWD_NAME=cod_shadowd
QSYST_EXECD_NAME=cod_execd
QSYST_QSTD_NAME=cod_qstd
QSYST_SHEPHERD_NAME=cod_shepherd
QSYST_COMMDCNTL_NAME=codcommdcntl

if [ $2 != 0 ]; then
   COMMDPORT_LINE="s/GENCOMMD_PORT/COMMD_PORT=$2/"
else
   COMMDPORT_LINE="/GENCOMMD_PORT/d"
fi

sed -e "s%QSYST_ROOT%${QSYST_ROOT}%g" \
    -e "s%QSYST_CELL%${QSYST_CELL}%g" \
    -e "s%QSYST_NAME%${QSYST_NAME}%g" \
    -e "s%QSYST_MASTER_NAME%${QSYST_MASTER_NAME}%g" \
    -e "s%QSYST_SCHEDD_NAME%${QSYST_SCHEDD_NAME}%g" \
    -e "s%QSYST_SHADOWD_NAME%${QSYST_SHADOWD_NAME}%g" \
    -e "s%QSYST_EXECD_NAME%${QSYST_EXECD_NAME}%g" \
    -e "s%QSYST_SHEPHERD_NAME%${QSYST_SHEPHERD_NAME}%g" \
    -e "s%QSYST_COMMDCNTL_NAME%${QSYST_COMMDCNTL_NAME}%g" \
    -e "s%GENROOT%${QSYST_ROOT_VAL}%g" \
    -e "s%GENCELL%${QSYST_CELL_VAL}%g" \
    -e "/#+-#+-#+-#-/,/#-#-#-#-#-#/d" \
    -e $COMMDPORT_LINE $4
