#!/bin/sh
#
# (c) 2000 Sun Microsystems, Inc.
#

# Install execution daemons on a given list of hosts via rsh access
# "$CODINE_ROOT" must be set in current environment.
# 
# $1 may be the string "-noqueue"
# this parameter will be passed to the "install_execd" script on the remote
# machine.
#

if [ "$CODINE_ROOT" = "" ]; then
   echo environment varibale \"\$CODINE_ROOT\" not set - installation failed
   exit 1
fi

if [ $# -lt 1 -o "$1" = "-h" -o "$1" = "-help" ]; then
   echo "install execution daemons via \"rsh\" access "
   echo
   echo "usage: $0 [-noqueue] host1 host2 host3 ..."
   echo "       -noqueue  do not add ad default queue when installing the exec host"
   echo
   echo The following command will be executed for all hosts given in the commandline:
   echo
   echo "   rsh <hostname> \"cd $CODINE_ROOT && ./install_execd -fast -auto [-noqueue]\""
   exit 1
fi

if [ "$1" = "-noqueue" ]; then
   noqueue=-noqueue
   shift
else
   noqueue=""
fi

if [ $# -lt 1 ]; then
   echo please give a list of hosts in command line where to install execution daemons
   exit 1
fi


for host in $*; do
   echo
   echo Installing execution daemon on host \"$host\"
   
   rsh $host "cd $CODINE_ROOT && ./install_execd -fast -auto $noqueue"
   echo ==============================================================================
done
