#!/bin/sh
#
# (c) 2000, 2001 Sun Microsystems, Inc.
#
# load sensor script for SGI-IRIX platform
#
# returns load value "iidle" as seconds of inactivity on tty's. Can be used
# to start computations on workstations with users logged in, but idle
#
# Do not forget to add the "iidle" complex value to to your "host" complex
# and to add a load threshold in your queues.
#
# The line in the host complex should be defined as follows ("shortcut" and
# "requestable" can be defined differently)
#
# name  shortcut   type   value    relop requestable consumable default
# iidle iidle      INT    INFINITY <=    NO          NO         0
#
# Be careful: Load sensor scripts are started with root permissions.
# In an admin_user system euid=0 and uid=admin_user
#

PATH=/bin:/usr/bin

ARCH=`$CODINE_ROOT/util/arch`
HOST=`$CODINE_ROOT/utilbin/$ARCH/gethostname -name`
FILESTAT=$CODINE_ROOT/utilbin/$ARCH/filestat

end=false
while [ $end = false ]; do
   read input
   result=$?
   if [ $result != 0 ]; then
      end=true
      break
   fi

   if [ "$input" = "quit" ]; then
      end=true
      break
   fi

   ACTIVETTYS=`/usr/bsd/w -h | awk '{print "/dev/tty"$2}' `
   LASTTTY=`ls -1t $ACTIVETTYS | head -1`
   TIMEOFLASTTTY=`$CODINE_ROOT/utilbin/$ARCH/filestat -mtime $LASTTTY`
   TIMENOW=`$CODINE_ROOT/utilbin/$ARCH/now`
   DIFF=`expr $TIMENOW - $TIMEOFLASTTTY`

   echo "begin"
   echo "$HOST:iidle:$DIFF"
   echo "end"

done
